# -*- mode: python; indent-tabs-mode: nil; tab-width: 3 -*-
# vim: set tabstop=3 shiftwidth=3 expandtab:
#
# Copyright (C) 2011 Tim Altmann, Christian Brandt
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#

import os
from gamera.toolkits.webcam.plugins import driverwrapper
import classwebcam
import cpp
import _pythondrivers as pydrivers
#import gamera.toolkits.webcam.drivers
cppdrivers = driverwrapper.CppDrivers()
if cppdrivers == "":
   cppdrivers = []
else:
   cppdrivers = cppdrivers.split("[/]")

pythondrivers = []
for d in dir(pydrivers):
   if d.startswith("webcam"):
      pythondrivers.append(d)

def driverList():
   return cppdrivers + pythondrivers


def driverInstance(name="default"):
   if name == "default":
      if len(cppdrivers) > 0:
         return cpp.WebcamCpp(cppdrivers[0])
      elif len(pythondrivers) > 0:
         return getattr(pydrivers, pythondrivers[0]).Webcam()
      return None

   if name in cppdrivers:
      return cpp.WebcamCpp(name)

   
   if name in pythondrivers:
      return getattr(pydrivers, name).Webcam()  

   return None

