# -*- mode: python; indent-tabs-mode: nil; tab-width: 3 -*-
# vim: set tabstop=3 shiftwidth=3 expandtab:
#
# Copyright (C) 2011 Tim Altmann, Christian Brandt
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#

from gamera.plugin import *

class Webcam:
   '''This class **Webcam** is a wrapper around the webcam C++-API and 
the main interface for people using the toolkit.'''

   def __init__(self, drivername):
      '''This method should not do anything, particularly it should not create 
      a session.'''
      pass

   def __del__(self):
      '''This method closes any opened session and frees used memory.'''
      closeSession()


   def initSession(self, width, height, device):
      '''Signature: 

   ``initSession (width, height, device)``
            
Starts a new camera session where *width* and *height* are the dimensions of the
resulting image and *device* is the identifier of the camera. If there is an 
exisiting camera session this session will be closed and a new session to the 
given camera is opened.'''
      self.width=width
      self.height=height
      return None



   def snapshotFromWebcam(self):
      '''Signature:

   ``snapshotFromWebcam ()``

Returns a RGB Gamera image taken from the webcam.
'''
      image = None
      return image



   def closeSession(self):
      '''Signature:

   ``closeSession ()``

Closes a existing camera session and frees used resources.
'''
      pass


   def getDevices(self):
      '''Signature:

   ``getDevices ()``

Returns a list of device names available on the current system.
'''
      
      devices = []
   
      return devices

 
