/*
 *
 * Copyright (C) 2011 Tim Altmann, Christian Brandt
 *
 * This toolkit is based on Tim Altmann's 2011 bachelor thesis
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _WEBCAM_QTKIT_HPP_816392964D7554
#define _WEBCAM_QTKIT_HPP_816392964D7554

#include "webcambase.hpp"

#define CLEAR(x) memset(&(x), 0, sizeof(x))

namespace WebcamToolkit {

struct buffer;



// -----------------------------------------------------------------------------
class WebcamQtkit: public Webcam {
public:
   /// initializes components needed for further actions
   WebcamQtkit();

   /// closes current session and frees reserved memory
   ~WebcamQtkit();
   
   virtual int initSession(int width, int height, char* device) ;
   virtual unsigned char* snapshotFromWebcam();
   virtual void closeSession();
   virtual std::string getDevices();


protected:
   void *snap;
   void *pool;
   
   void *getDevicesByName(char* deviceName);
};

} //end WebcamToolkit::

#endif /* _WEBCAM_V4L_HPP_816392964D7554 */

